// Generated by ReScript, PLEASE EDIT WITH CARE

import * as Fs from "fs";
import * as Js_exn from "rescript/lib/es6/js_exn.js";
import * as Readline from "readline";
import * as Caml_js_exceptions from "rescript/lib/es6/caml_js_exceptions.js";

function readFirstLine(filePath) {
  var readStream = Fs.createReadStream(filePath);
  var rl = Readline.createInterface({
        input: readStream,
        crlfDelay: Infinity
      });
  return new Promise((function (resolve, _reject) {
                rl.on("line", (function (line) {
                        rl.close();
                        readStream.destroy();
                        resolve({
                              TAG: "Ok",
                              _0: line
                            });
                      }));
                rl.on("error", (function (_err) {
                        resolve({
                              TAG: "Error",
                              _0: undefined
                            });
                      }));
              }));
}

function readLines(filePath, callback) {
  var readStream = Fs.createReadStream(filePath);
  var rl = Readline.createInterface({
        input: readStream,
        crlfDelay: Infinity
      });
  return new Promise((function (resolve, _reject) {
                rl.on("line", (function (line) {
                        callback(line);
                      }));
                rl.on("close", (function (param) {
                        resolve({
                              TAG: "Ok",
                              _0: undefined
                            });
                      }));
                rl.on("error", (function (_err) {
                        resolve({
                              TAG: "Error",
                              _0: undefined
                            });
                      }));
              }));
}

var ReadFile = {
  readFirstLine: readFirstLine,
  readLines: readLines
};

var commentOpen = "/*";

var docCommentOpen = "/**";

var commentClose = "*/";

var ending = "`)";

async function findContentInFile(filePath, tags) {
  var tags$1 = tags.map(function (t) {
        return t + "(\`";
      });
  var foundContent = [];
  var lineCount = {
    contents: 0
  };
  var inComment = {
    contents: false
  };
  var pushingContent = {
    contents: undefined
  };
  try {
    await readLines(filePath, (function (line) {
            var currentLine = lineCount.contents;
            lineCount.contents = lineCount.contents + 1 | 0;
            var $$break = false;
            var trimmedLine = line.trim();
            var isSingleLineComment = trimmedLine.startsWith("//");
            if (inComment.contents && line.includes(commentClose)) {
              inComment.contents = false;
              $$break = true;
            } else if (inComment.contents) {
              $$break = true;
            } else if (!inComment.contents && (trimmedLine.startsWith(docCommentOpen) || trimmedLine.startsWith(commentOpen))) {
              inComment.contents = true;
              $$break = true;
            }
            if (isSingleLineComment) {
              $$break = true;
            }
            if ($$break) {
              return ;
            }
            var c = pushingContent.contents;
            if (c !== undefined) {
              if (line.includes(ending)) {
                var match = line.split(ending);
                if (match.length === 2) {
                  var before = match[0];
                  var lastLine = line.split(ending)[0];
                  c.content.push(lastLine);
                  foundContent.push({
                        tag: c.tag,
                        content: c.content,
                        start: c.start,
                        end: {
                          line: currentLine,
                          col: before.length
                        }
                      });
                }
                pushingContent.contents = undefined;
                return ;
              }
              c.content.push(line);
              return ;
            }
            var tagOnLine = tags$1.find(function (tag) {
                  return line.includes(tag);
                });
            if (tagOnLine === undefined) {
              return ;
            }
            var match$1 = line.split(tagOnLine);
            if (match$1.length !== 2) {
              return ;
            }
            var before$1 = match$1[0];
            var after = match$1[1];
            var startPos_col = before$1.length + tagOnLine.length | 0;
            var startPos = {
              line: currentLine,
              col: startPos_col
            };
            pushingContent.contents = {
              tag: tagOnLine.replace("(`", ""),
              content: [after],
              start: startPos,
              end: startPos
            };
          }));
    return foundContent;
  }
  catch (raw_exn){
    var exn = Caml_js_exceptions.internalToOCamlException(raw_exn);
    if (exn.RE_EXN_ID === Js_exn.$$Error) {
      return foundContent;
    }
    throw exn;
  }
}

async function extractContentInFile(filePath, tags) {
  var content = await findContentInFile(filePath, tags);
  return content.map(function (c) {
              return {
                      content: c.content.join("\n"),
                      start: c.start,
                      end: c.end,
                      tag: c.tag
                    };
            });
}

export {
  ReadFile ,
  commentOpen ,
  docCommentOpen ,
  commentClose ,
  ending ,
  findContentInFile ,
  extractContentInFile ,
}
/* fs Not a pure module */
